<?php

class hvlayout {
   var $_id = 0;
   var $_images = array();
   var $_width= 600;
   var $_padding= 3;
   var $_img_template= '<img src="[src]" />';
   var $_swap_list = "0";

   function hvlayout($width=600, $padding=3, $imagetemplate='', $args){
      $this->_width = $width;
      $this->_padding = $padding;

      if ($imagetemplate != ''){
         $this->_imagetemplate = $imagetemplate;
      }

      if( $args){
         $this->_swap_list= $args[0];
      }
   }
   
   function do_layout(){
      while( count($this->_images) > 1){
         $this->sort_images();

         $this->do_layout_step();
      }

/*
      if($this->_padding > 0){
        // TODO : solve include problem see image_composition.module
        // require_once( './../math/matrix.class.php');

         $this->_equations = array();
         $this->_b = array();
         $this->_A = array();

         $this->add_borders( $this->_images[0]);

         // get all variable names
         $m_keys= array();
         foreach( $this->_A as $row){
            foreach( $row as $var => $value){
               $m_keys[ $var]++;
            }
         }

         $m = new matrix();
         $m->set_col_keys( array_keys( $m_keys));
         $m->set_row_keys( array_keys( $this->_A));


#print_r( $m_keys);
         $r=0;
         foreach( $this->_A as $in_row){
            foreach( $in_row as $var => $value){
              $m->set_value( $r, $var, $value);
            }
            $r++;
         }

$m->replace_vars( $this->_values);
$m->_fill_empty();
#$m->_print();

$b = new Matrix();
$b->set_row_keys( array(0));
$b->set_col_keys( array_keys( $this->_b));
$b->_A[0]=$this->_b;
$b->replace_vars( array( 'b'=>3));
#$b->transpose()->_print(false);

$g = new GaussianElimination();
$x = $g->solve( $m->_A, $b->_A[0]);
#print_r( $x);


     }
   */
   }

   /** 
    * add_borders
    *
    * to add borders we need to gather all equations
    * h(i_1,i_2) reads: horizontal layout of images 1 and 2
    * v(i_1,i_2) reads: vertical layout of images 1 and 2
    *
    * What is width and heigt of h(i_1,i_2) of v(i_1,i_2) 
    * when adding a border b (width or height)?
    *
    * known values are: w_1, h_1, w_2, h_2, b
    * unknown values are: s_1, s_2, w_total, h_total
    *
    * DO NOT scale a composition
    * where w_i became a variable
    */
   function add_borders( &$image){
      if( $image['images']){
         # add equations
         $im_1 = $image['images'][0];
         $im_2 = $image['images'][1];

         $id_1 = $im_1['_id'];
         $id_2 = $im_2['_id'];
         $id_total = $image['_id'];

         $s_1 = 's_' . $id_1;
         $w_1 = 'w_' . $id_1;
         $h_1 = 'h_' . $id_1;

         if( $im_1['images']){
            $s_1 = '1';
         } else {
            $this->_values[ $w_1] = $im_1['width'];
            $this->_values[ $h_1] = $im_1['height'];
         }

         $s_2 = 's_' . $id_2;
         $w_2 = 'w_' . $id_2;
         $h_2 = 'h_' . $id_2;

         if( $im_2['images']){
            $s_2 = '1';
         } else {
            $this->_values[ $w_2] = $im_2['width'];
            $this->_values[ $h_2] = $im_2['height'];
         }

         $w_total = 'w_' . $id_total;
         $h_total = 'h_' . $id_total;

         if( $image['composition']=='h'){
            /*
             * w_h(1,2) : w_total == s_1 * w_1 + b + s_2 * w_2
             * h_h(1,2) : h_total == s_1 * h_1 == s_2 * h_2
             * ==>
             * s_1 * w_1 + s_2 * w_2 - 1 * w_total == b
             * s_1 * h_1 - s_2 * h_2               == 0
             * s_1 * h_1             - 1 * h_total == 0
             */
            $this->_equations[] = $s_1 . ' * ' . $w_1 . ' + ' . $s_2 . ' * ' . $w_2 . ' - 1 * ' . $w_total . ' = b';
            $row = array();
            $row[ ( $s_1== 1 ? $w_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $w_1);
            $row[ ( $s_2== 1 ? $w_2: $s_2)] = ( $s_2 == 1 ? $s_2 : $w_2);
            $row[ $w_total] = -1;
            $this->_A[] = $row;
            $this->_b[] = b;

            $this->_equations[] = $s_1 . ' * ' . $h_1 . ' - ' . $s_2 . ' * ' . $h_2 .                        ' = 0';
            $row = array();
            $row[ ( $s_1== 1 ? $h_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $h_1);
            $row[ ( $s_2== 1 ? $h_2: $s_2)] = '-' . ( $s_2 == 1 ? $s_2 : $h_2);
            $this->_A[] = $row;
            $this->_b[] = 0;

            $this->_equations[] = $s_1 . ' * ' . $h_1 .                               ' - 1 * ' . $h_total . ' = 0';
            $row = array();
            $row[ ( $s_1== 1 ? $h_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $h_1);
            $row[ $h_total] = -1;
            $this->_A[] = $row;
            $this->_b[] = 0;
         } else {
            /*
             * w_v(1,2) : w_total == s_1 * w_1 == s_2 * w_2
             * h_v(1,2) : h_total == s_1 * h_1 + b + s_2 * h_2
             * ==>
             * s_1 * w_1 - s_2 * w_2               == 0
             * s_1 * h_1 + s_2 * h_2 - 1 * h_total == b
             * s_1 * w_1             - 1 * w_total == 0
             */
            $this->_equations[] = $s_1 . ' * ' . $w_1 . ' - ' . $s_2 . ' * ' . $w_2 .                        ' = 0';
            $row = array();
            $row[ ( $s_1== 1 ? $w_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $w_1);
            $row[ ( $s_2== 1 ? $w_2: $s_2)] = '-' . ( $s_2 == 1 ? $s_2 : $w_2);
            $this->_A[] = $row;
            $this->_b[] = 0;

            $this->_equations[] = $s_1 . ' * ' . $h_1 . ' + ' . $s_2 . ' * ' . $h_2 . ' - 1 * ' . $h_total . ' = b';
            $row = array();
            $row[ ( $s_1== 1 ? $h_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $h_1);
            $row[ ( $s_2== 1 ? $h_2: $s_2)] = ( $s_2 == 1 ? $s_2 : $h_2);
            $row[ $h_total] = -1;
            $this->_A[] = $row;
            $this->_b[] = b;

            $this->_equations[] = $s_1 . ' * ' . $w_1 .                               ' - 1 * ' . $w_total . ' = 0';
            $row = array();
            $row[ ( $s_1== 1 ? $w_1: $s_1)] = ( $s_1 == 1 ? $s_1 : $w_1);
            $row[ $w_total] = -1;
            $this->_A[] = $row;
            $this->_b[] = 0;
         }
         $this->add_borders($im_1);
         $this->add_borders($im_2);
      }
   }

   function get_var_if( $var, $scalar, $get_var= true){
      if($var == 1){
         return $scalar;
      } else {
         return $var? $var: $scalar;
      }
   }

   function get_html(){
      $swap_list= $this->_swaplist;
      $width= $this->_width;

      $this->do_layout();

      $im = $this->_images[ 0];

      return '<div class="image-composition">'
          . $this->to_html_composition($im, $width, 0, 0, $swap_list)
          . '</div><div style="clear: both;"></div>';
   }

   function to_html_composition(&$im, $width, $top= 0, $left= 0, $swap_list= "0"){
      $result='';

      $ratio= $im["ratio"];

      if( $im["composition"]){
         list($in1, $in2) = ( $swap_list[0]=="0") ? array(0,1) : array( 1,0);

         $swap_list= substr($swap_list, 1) . $swap_list[0];

         $result.= '<div>';

         if( $im["composition"] == 'v'){
            $height= ($im["images"][$in1]["ratio"]) * $width;

            $result.= '<div style="float:left; clear:both">';
            $result.= $this->to_html_composition( $im["images"][$in1],
                $width, $top, $left, $swap_list);
            $result.= "</div>";

            $result.= '<div style="float:left; clear:both;">';
            $result.= $this->to_html_composition( $im["images"][$in2],
                $width, $top + $height, $left, $swap_list);
            $result.= "</div>";

         } else {
            $height= $ratio * $width;
            $w1= $height / $im["images"][$in1]["ratio"] ;
            // horizontal
            $result.= '<div style="float:left; clear:both">';
            $result.= $this->to_html_composition( $im["images"][$in1],
                $w1, $top, $left, $swap_list);
            $result.= "</div>";

            $result.= '<div style="float:left;">';
            $result.= $this->to_html_composition( $im["images"][$in2],
                $width-$w1, $top, $left+ $w1, $swap_list);
            $result.= "</div>";
         }
         $result.= "</div>";
      } else {
         $height= $ratio * $width;

         $result.= "\n" . '<img alt="' . $im['_id'] . '" src="' . $im['url'] 
            . '" width="' . floor($width) . '" height="' . floor($height)
            . '"/>' . "\n";
      }

      return $result;
   }

   function do_layout_step(){

      $im1 = array_pop( $this->_images);

      $w1 = $im1['width'];
      $h1 = $im1['height'];
      $t1 = $im1['type'];
      $a1 = $im1["ratio"];

      $im2 = array_pop( $this->_images);

      $w2 = $im2['width'];
      $h2 = $im2['height'];
      $t2 = $im2['type'];

      $sequence = "$t1$t2";

      if( $t1=='P' ){
         // horizontal has preference
         $composition = "h";

         $h = min( $h1, $h2);
         $w = ($w1 / $h1 + $w2 / $h2) * $h;
         $q = $h * $h;
         $ratio = $h/$w;

         $im1["_width"] = $h / $im1["ratio"];
         $im1["_height"] = $h;
         $im2["_width"] = $h / $im2["ratio"];
         $im2["_height"] = $h;

      } else {
         $composition = "v";

         $w = min( $w1, $w2);
         $h = ( $h1 / $w1 + $h2 / $w2) * $w;
         $q = $w * $h;
         $ratio = $h/$w;

         $im1["_width"] = $w;
         $im1["_height"] = $w * $im1["ratio"];
         $im2["_width"] = $w;
         $im2["_height"] = $w * $im2["ratio"];

      }

      $type = $h>$w ? 'P' : 'L';

      array_push( $this->_images
         , array( 'ratio'=> $ratio
               , 'width' => $w
               , 'height'=> $h
               , 'quality' => $q
               , 'composition'=> $composition
               , '_id' => $this->get_id()
               , 'type' => $type
               , 'images' => array($im1, $im2)
               )
         );
   }

   function add_image($image){
      $filename = $image["filename"];

      list($w, $h) = getimagesize($filename);

      if($w==0 || $h==0){
         return;
      }

      $ratio = $h/$w;

      $this->_images[] = array( 'filename' => $filename
                              , 'width'=>$w
                              , 'url'=> $image['url']
                              , 'height'=>$h
                              , 'quality' => ($w*$h)
                              , 'ratio' => $ratio
                              , 'type'=> ($ratio<1? 'L':'P')
                              , '_id' => $this->get_id()
                              );
   }

   function sort_images(){
      foreach ($this->_images as $key => $row) {
          $quality[$key]  = $row['quality'];
      }

      // sort on quality then on type
      array_multisort( $quality, SORT_DESC, $this->_images);
   }

   function get_id(){
      return $this->_id++;
   }
}
